-- phpMyAdmin SQL Dump
-- version 4.7.9
-- https://www.phpmyadmin.net/
--
-- Hôte : 127.0.0.1:3306
-- Généré le :  mer. 06 juin 2018 à 08:48
-- Version du serveur :  5.7.21
-- Version de PHP :  7.2.4

SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET AUTOCOMMIT = 0;
START TRANSACTION;
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;

--
-- Base de données :  `entrepot`
--

-- --------------------------------------------------------

--
-- Structure de la table `horaire__personne`
--

DROP TABLE IF EXISTS `horaire__personne`;
CREATE TABLE IF NOT EXISTS `horaire__personne` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `civ` enum('M','Mme') NOT NULL,
  `nom_naissance` varchar(100) NOT NULL,
  `nom_usage` varchar(200) DEFAULT NULL,
  `prenom` varchar(100) NOT NULL,
  `naissance` date NOT NULL,
  `mail` varchar(200) DEFAULT NULL,
  `inscription` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  KEY `mail` (`mail`),
  KEY `nom_naissance` (`nom_naissance`) USING BTREE,
  KEY `nom_usage` (`nom_usage`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;

--
-- Déchargement des données de la table `horaire__personne`
--

INSERT INTO `horaire__personne` (`id`, `civ`, `nom_naissance`, `nom_usage`, `prenom`, `naissance`, `mail`, `inscription`) VALUES
(1, 'Mme', 'DUPONT', 'ZARMA', 'Corinne', '1965-12-31', 'cdupont@gmail.com', '2018-06-06 06:41:30'),
(2, 'M', 'ZARMA', NULL, 'Kamel', '1972-04-01', 'cdupont@gmail.com', '2018-06-06 06:48:45'),
(3, 'Mme', 'POPEYE', NULL, 'Louise', '2000-01-01', 'popeye@numericable.fr', '2018-06-06 06:50:12');

-- --------------------------------------------------------

--
-- Structure de la table `horaire__saisie`
--

DROP TABLE IF EXISTS `horaire__saisie`;
CREATE TABLE IF NOT EXISTS `horaire__saisie` (
  `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT,
  `personne_id` int(11) NOT NULL,
  `jour` date NOT NULL,
  `debut` time NOT NULL,
  `fin` time NOT NULL,
  PRIMARY KEY (`id`),
  KEY `personne_id` (`personne_id`),
  KEY `jour` (`jour`),
  KEY `debut` (`debut`),
  KEY `fin` (`fin`),
  KEY `periode` (`jour`,`debut`,`fin`)
) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=utf8 ROW_FORMAT=COMPRESSED;

--
-- Déchargement des données de la table `horaire__saisie`
--

INSERT INTO `horaire__saisie` (`id`, `personne_id`, `jour`, `debut`, `fin`) VALUES
(1, 1, '2018-06-01', '09:30:00', '14:00:00'),
(2, 1, '2018-06-01', '14:00:00', '18:00:00'),
(3, 1, '2018-06-04', '08:00:00', '11:50:00'),
(4, 1, '2018-06-04', '13:00:00', '18:15:00'),
(5, 2, '2018-06-01', '05:00:00', '13:00:00'),
(6, 2, '2018-06-04', '13:00:00', '21:00:00'),
(7, 3, '2018-06-01', '08:00:00', '23:59:59'),
(8, 3, '2018-05-31', '08:00:00', '20:00:00');

--
-- Déclencheurs `horaire__saisie`
--
DROP TRIGGER IF EXISTS `insert_erreur`;
DELIMITER $$
CREATE TRIGGER `insert_erreur` BEFORE INSERT ON `horaire__saisie` FOR EACH ROW BEGIN
  DECLARE _msg  varchar(255);
 
  if (new.debut >= new.fin) then
        set _msg = concat('Insertion interdite ! horaire debut plus grand que horaire fin !');
     SIGNAL SQLSTATE VALUE '08888' SET MESSAGE_TEXT = _msg, MYSQL_ERRNO = 8888;
  end if;
  if exists (select 1 from horaire__saisie where personne_id = new.personne_id and jour = new.jour and fin > new.debut and debut < new.fin) then
		set _msg = concat('Insertion interdite ! La période saisie recoupe une période déjà saisie !');
     SIGNAL SQLSTATE VALUE '07777' SET MESSAGE_TEXT = _msg, MYSQL_ERRNO = 7777;
  end if;
END
$$
DELIMITER ;
DROP TRIGGER IF EXISTS `update_erreur`;
DELIMITER $$
CREATE TRIGGER `update_erreur` BEFORE UPDATE ON `horaire__saisie` FOR EACH ROW BEGIN
  DECLARE _msg  varchar(255);
 
  if (new.debut >= new.fin) then
         set _msg = concat('Modification interdite ! horaire debut plus grand que horaire fin !');
     SIGNAL SQLSTATE VALUE '08888' SET MESSAGE_TEXT = _msg, MYSQL_ERRNO = 8888;
  end if;
  if exists (select 1 from horaire__saisie where id != new.id and personne_id=new.personne_id and jour = new.jour and fin > new.debut and debut < new.fin) then
        set _msg = concat('Modification interdite ! La période saisie recoupe une période déjà saisie !');
     SIGNAL SQLSTATE VALUE '07777' SET MESSAGE_TEXT = _msg, MYSQL_ERRNO = 7777;
  end if;
 
END
$$
DELIMITER ;

-- --------------------------------------------------------

--
-- Doublure de structure pour la vue `v_an`
-- (Voir ci-dessous la vue réelle)
--
DROP VIEW IF EXISTS `v_an`;
CREATE TABLE IF NOT EXISTS `v_an` (
`an` varchar(4)
,`cumul` time
);

-- --------------------------------------------------------

--
-- Doublure de structure pour la vue `v_an_personne`
-- (Voir ci-dessous la vue réelle)
--
DROP VIEW IF EXISTS `v_an_personne`;
CREATE TABLE IF NOT EXISTS `v_an_personne` (
`personne_id` int(11)
,`civ` enum('M','Mme')
,`nom` varchar(200)
,`prenom` varchar(100)
,`age` bigint(21)
,`mail` varchar(200)
,`an` varchar(4)
,`cumul` time
);

-- --------------------------------------------------------

--
-- Doublure de structure pour la vue `v_jour`
-- (Voir ci-dessous la vue réelle)
--
DROP VIEW IF EXISTS `v_jour`;
CREATE TABLE IF NOT EXISTS `v_jour` (
`jour` date
,`cumul` time
);

-- --------------------------------------------------------

--
-- Doublure de structure pour la vue `v_jour_personne`
-- (Voir ci-dessous la vue réelle)
--
DROP VIEW IF EXISTS `v_jour_personne`;
CREATE TABLE IF NOT EXISTS `v_jour_personne` (
`personne_id` int(11)
,`civ` enum('M','Mme')
,`nom` varchar(200)
,`prenom` varchar(100)
,`age` bigint(21)
,`mail` varchar(200)
,`jour` date
,`cumul` time
);

-- --------------------------------------------------------

--
-- Doublure de structure pour la vue `v_mois`
-- (Voir ci-dessous la vue réelle)
--
DROP VIEW IF EXISTS `v_mois`;
CREATE TABLE IF NOT EXISTS `v_mois` (
`mois` varchar(7)
,`cumul` time
);

-- --------------------------------------------------------

--
-- Doublure de structure pour la vue `v_mois_personne`
-- (Voir ci-dessous la vue réelle)
--
DROP VIEW IF EXISTS `v_mois_personne`;
CREATE TABLE IF NOT EXISTS `v_mois_personne` (
`personne_id` int(11)
,`civ` enum('M','Mme')
,`nom` varchar(200)
,`prenom` varchar(100)
,`age` bigint(21)
,`mail` varchar(200)
,`mois` varchar(7)
,`cumul` time
);

-- --------------------------------------------------------

--
-- Doublure de structure pour la vue `v_semaine`
-- (Voir ci-dessous la vue réelle)
--
DROP VIEW IF EXISTS `v_semaine`;
CREATE TABLE IF NOT EXISTS `v_semaine` (
`semaine` varchar(7)
,`cumul` time
);

-- --------------------------------------------------------

--
-- Doublure de structure pour la vue `v_semaine_personne`
-- (Voir ci-dessous la vue réelle)
--
DROP VIEW IF EXISTS `v_semaine_personne`;
CREATE TABLE IF NOT EXISTS `v_semaine_personne` (
`personne_id` int(11)
,`civ` enum('M','Mme')
,`nom` varchar(200)
,`prenom` varchar(100)
,`age` bigint(21)
,`mail` varchar(200)
,`semaine` varchar(7)
,`cumul` time
);

-- --------------------------------------------------------

--
-- Structure de la vue `v_an`
--
DROP TABLE IF EXISTS `v_an`;

CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `v_an`  AS  select date_format(`h`.`jour`,'%Y') AS `an`,sec_to_time(sum(time_to_sec(timediff(`h`.`fin`,`h`.`debut`)))) AS `cumul` from `horaire__saisie` `h` group by `an` order by `an` desc ;

-- --------------------------------------------------------

--
-- Structure de la vue `v_an_personne`
--
DROP TABLE IF EXISTS `v_an_personne`;

CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `v_an_personne`  AS  select `h`.`personne_id` AS `personne_id`,`p`.`civ` AS `civ`,if(isnull(`p`.`nom_usage`),`p`.`nom_naissance`,`p`.`nom_usage`) AS `nom`,`p`.`prenom` AS `prenom`,timestampdiff(YEAR,`p`.`naissance`,`h`.`jour`) AS `age`,`p`.`mail` AS `mail`,date_format(`h`.`jour`,'%Y') AS `an`,sec_to_time(sum(time_to_sec(timediff(`h`.`fin`,`h`.`debut`)))) AS `cumul` from (`horaire__saisie` `h` join `horaire__personne` `p` on((`h`.`personne_id` = `p`.`id`))) group by `h`.`personne_id`,`an` order by `nom`,`p`.`prenom`,`an` desc ;

-- --------------------------------------------------------

--
-- Structure de la vue `v_jour`
--
DROP TABLE IF EXISTS `v_jour`;

CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `v_jour`  AS  select `h`.`jour` AS `jour`,sec_to_time(sum(time_to_sec(timediff(`h`.`fin`,`h`.`debut`)))) AS `cumul` from `horaire__saisie` `h` group by `h`.`jour` order by `h`.`jour` desc ;

-- --------------------------------------------------------

--
-- Structure de la vue `v_jour_personne`
--
DROP TABLE IF EXISTS `v_jour_personne`;

CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `v_jour_personne`  AS  select `h`.`personne_id` AS `personne_id`,`p`.`civ` AS `civ`,if(isnull(`p`.`nom_usage`),`p`.`nom_naissance`,`p`.`nom_usage`) AS `nom`,`p`.`prenom` AS `prenom`,timestampdiff(YEAR,`p`.`naissance`,`h`.`jour`) AS `age`,`p`.`mail` AS `mail`,`h`.`jour` AS `jour`,sec_to_time(sum(time_to_sec(timediff(`h`.`fin`,`h`.`debut`)))) AS `cumul` from (`horaire__saisie` `h` join `horaire__personne` `p` on((`h`.`personne_id` = `p`.`id`))) group by `h`.`personne_id`,`h`.`jour` order by `nom`,`p`.`prenom`,`h`.`jour` desc ;

-- --------------------------------------------------------

--
-- Structure de la vue `v_mois`
--
DROP TABLE IF EXISTS `v_mois`;

CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `v_mois`  AS  select date_format(`h`.`jour`,'%Y-%m') AS `mois`,sec_to_time(sum(time_to_sec(timediff(`h`.`fin`,`h`.`debut`)))) AS `cumul` from `horaire__saisie` `h` group by `mois` order by `mois` desc ;

-- --------------------------------------------------------

--
-- Structure de la vue `v_mois_personne`
--
DROP TABLE IF EXISTS `v_mois_personne`;

CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `v_mois_personne`  AS  select `h`.`personne_id` AS `personne_id`,`p`.`civ` AS `civ`,if(isnull(`p`.`nom_usage`),`p`.`nom_naissance`,`p`.`nom_usage`) AS `nom`,`p`.`prenom` AS `prenom`,timestampdiff(YEAR,`p`.`naissance`,`h`.`jour`) AS `age`,`p`.`mail` AS `mail`,date_format(`h`.`jour`,'%Y-%m') AS `mois`,sec_to_time(sum(time_to_sec(timediff(`h`.`fin`,`h`.`debut`)))) AS `cumul` from (`horaire__saisie` `h` join `horaire__personne` `p` on((`h`.`personne_id` = `p`.`id`))) group by `h`.`personne_id`,`mois` order by `nom`,`p`.`prenom`,`mois` desc ;

-- --------------------------------------------------------

--
-- Structure de la vue `v_semaine`
--
DROP TABLE IF EXISTS `v_semaine`;

CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `v_semaine`  AS  select distinct concat(substr(yearweek(`h`.`jour`,2),1,4),'-',substr(yearweek(`h`.`jour`,2),5)) AS `semaine`,sec_to_time(sum(time_to_sec(timediff(`h`.`fin`,`h`.`debut`)))) AS `cumul` from `horaire__saisie` `h` group by yearweek(`h`.`jour`,2) order by yearweek(`h`.`jour`,2) desc ;

-- --------------------------------------------------------

--
-- Structure de la vue `v_semaine_personne`
--
DROP TABLE IF EXISTS `v_semaine_personne`;

CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `v_semaine_personne`  AS  select distinct `h`.`personne_id` AS `personne_id`,`p`.`civ` AS `civ`,if(isnull(`p`.`nom_usage`),`p`.`nom_naissance`,`p`.`nom_usage`) AS `nom`,`p`.`prenom` AS `prenom`,timestampdiff(YEAR,`p`.`naissance`,`h`.`jour`) AS `age`,`p`.`mail` AS `mail`,concat(substr(yearweek(`h`.`jour`,2),1,4),'-',substr(yearweek(`h`.`jour`,2),5)) AS `semaine`,sec_to_time(sum(time_to_sec(timediff(`h`.`fin`,`h`.`debut`)))) AS `cumul` from (`horaire__saisie` `h` join `horaire__personne` `p` on((`h`.`personne_id` = `p`.`id`))) group by `h`.`personne_id`,yearweek(`h`.`jour`,2) order by `nom`,`p`.`prenom`,yearweek(`h`.`jour`,2) desc ;

--
-- Contraintes pour les tables déchargées
--

--
-- Contraintes pour la table `horaire__saisie`
--
ALTER TABLE `horaire__saisie`
  ADD CONSTRAINT `personne_fk` FOREIGN KEY (`personne_id`) REFERENCES `horaire__personne` (`id`);
COMMIT;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
